/*
SUSIE32 '00AM' Plug-in for LZH(LH0̂)
*/

#include <windows.h>
#include "spi00am.h"
#include "spi00am_ex.h"

CommonCache *cache;

//---------------------------------------------------------------------------
/* Gg|Cg */
BOOL APIENTRY SpiEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	g_hModule = hModule;
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			loadConfig();
			cache = new CommonCache();
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

//---------------------------------------------------------------------------
/*
wb_đΉtH[}bgmF.
ΉĂ̂Ȃtrue,łȂfalseԂ.
filname̓t@C(NULLĂ邱Ƃ).
data̓t@C̃wb_,TCY HEADBUF_SIZE.
*/
/* 2KBȓ */
BOOL IsSupportedEx(char *filename, char *data)
{
	if (memcmp(data, "%PDF-", 5) != 0) return FALSE;
	return TRUE;
}
//---------------------------------------------------------------------------
/*
filname̓t@C.
len͓ǂݍ݊JnItZbg(MacBinΉ̂).
lphInf̓t@C̓nh󂯎ϐւ̃|C^.
A[JCu擾.G[R[hԂ.

A[JCu͓ƎɂxLbVB
GetArchiveInfo ł *A[JCut@C* ̈v̂ԂB
GetFileInfo ł̓A[JCu *t@C* ̈v̂ԂB
GetFileEx œn fileInfo  *position* ̈v̂nB
*/
int GetArchiveInfoEx(LPSTR filename_b, long len, HLOCAL *lphInf)
{
	char *filename = getFilename(filename_b);
	llog(filename);
	cache->Init(filename);
	int ret;
	ret = cache->Dupli(filename, lphInf);
	if (ret != SPI_NO_FUNCTION) {
		return ret;
	}
	return GetArchiveInfoExCache(filename, len, lphInf, cache);
	/*
	pdf_xref *xref;
	pdf_page *page;
	int fcount = 0;
	unsigned long filesize;
	fz_error error;

	error = pdf_open_xref(&xref, filename, NULL);
	if (error) { return SPI_FILE_READ_ERROR;}
	if (pdf_needs_password(xref)) {
		return SPI_FILE_READ_ERROR;
	}
	error = pdf_load_page_tree(xref);
	if (error) { return SPI_FILE_READ_ERROR;}
	fcount = pdf_count_pages(xref);
	*lphInf = LocalAlloc(LPTR, sizeof(fileInfo)*(fcount+1));
	if (*lphInf == NULL) {
		pdf_free_xref(xref);
		return SPI_NO_MEMORY;
	}
	fileInfo *pinfo = (fileInfo *)*lphInf;
	HLOCAL dest;
	for (int i=0; i < fcount; i++) {
		error = pdf_load_page(&page, xref, i);
		int ret = GetJpegToMemory(&dest, &filesize, xref, page, g_resolution);
		pdf_free_page(page);
		if (ret != 0) { pdf_free_xref(xref); return ret;}
		LocalFree(dest);
		// Method(7+'\0'ȓł̓Kȕԋp) 
		lstrcpy((char*)pinfo->method, "MuPDF");
		pinfo->position = i;
		pinfo->compsize = filesize;
		pinfo->filesize = filesize;
		pinfo->timestamp = 0;
		sprintf((char*)pinfo->filename, "%03d.jpg", i);
		pinfo->crc = 0;
		pinfo++;
	}
	pinfo->method[0] = '\0';
	pdf_free_xref(xref);
	*/

	return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
/*
dest,t@C̓LOCAL[nh󂯎ϐւ̃|C^.
w肳ꂽfileInfo\̂ւ̃|C^.
G[R[hԂ.
*/
int GetFileEx(char *filename, HLOCAL *dest, fileInfo *pinfo,
			SPI_PROGRESS lpPrgressCallback, long lData)
{
	llog("GetFileEx");
	pdf_xref *xref;
	pdf_page *page;
	fz_error error;
	int pagenum = pinfo->position;
	unsigned long filesize;
	error = pdf_open_xref(&xref, filename, NULL);
	if (error) {
		llog("open error");
		return SPI_MEMORY_ERROR;
	}
	error = pdf_load_page_tree(xref);
	if (error) {
		llog("tree error");
		pdf_free_xref(xref);
		return SPI_FILE_READ_ERROR;
	}
	error = pdf_load_page(&page, xref, pagenum);
	if (error) {
		llog("load page error");
		pdf_free_xref(xref);
		return SPI_FILE_READ_ERROR;
	}
	GetJpegToMemory(dest, &filesize, xref, page, g_resolution);
	pdf_free_page(page);
	pdf_free_xref(xref);
	return SPI_ALL_RIGHT;
}

